{{ ---------------------------------------------------------------------------------------------------------

Hive-Computer-Projekt: Kommando "xload" - xmodem-upload

12-03-2009      - erste version aus jeff ledger'spropcomm extrahiert und angepasst
13-08-2009      - Version von Julian erweitert
14-08-2009      - Q'n'D EOF Fix

 --------------------------------------------------------------------------------------------------------- }}


OBJ
        ios     : "ios"
        ser     : "FullDuplexSerial256"       ' Full Duplex Serial Controller

CON

_CLKMODE     = XTAL1 + PLL16X
_XINFREQ     = 5_000_000

CON

   '' Xmodem
   
   SOH               = 1               ' Packet Start
   STX               = 2
   EOT               = 4               ' End of Transmission
   ACK               = 6               ' Positive Acknowledgement
   NAK               = 21              ' Negative Acknowledgement
   CAN               = 24              ' Cancel
   PAD               = 26              ' Padding at the end of the file
   RX_Buffer         = 20


CON

   serXmit   = 30                     ' Serial Transmit
   serRecv   = 31                     ' Serial Receive
   baud      = 9600                   ' Baud Rate
   PARALEN   = 32                     ' cmd stuff  
VAR

     BYTE CRC                          ' XMODEM Protocol
     BYTE PACKET                       ' XMODEM Protocol
     BYTE XRECV                        ' XMODEM Protocol
     BYTE MODE                         ' XMODEM Protocol
     BYTE RETRY                        ' XMODEM Protocol
     BYTE XBUF[128]                    ' XMODEM Protocol
     byte parastr[PARALEN]             ' CMD Stuff
     byte modus
     byte EOF                          ' EOF Flag

PUB main
 ios.start

' code fr test im ram, sollte bei bin-datei auskommentiert werden
' ios.startram
  modus := 0 
  ios.print(@msg0)                                      ' version anzeigen
  ios.parastart
  rdpara
  if modus == 1
    checkfile
  if modus == 2
    ser.start(serRecv,serXmit,0,baud)                     ' schnittstelle initialisieren
    xload                                                 ' transfer ausfhren
    ser.stop
  ios.paradel
  ios.stop                                              ' anwendung beenden

PUB checkfile | status
  status := ios.sdopen("r",@parastr)                   'test ob datei vorhanden
  ios.sdclose                                           'datei gleich wieder schlieen
  if status == 0                                        'datei ist schon vorhanden
    ios.print(@msg9)
    if ios.keywait <> "j"
      modus := 0
      ios.print(string("nein"))
      ios.printnl
    else
      modus := 2
      ios.print(string("ja"))
      ios.printnl
  else
    modus := 2
      
PUB xload | TCNT 

' mode = 0                      transfer inaktiv
' mode = 1                      transfer aktiv
' mode = 2                      transfer beendet (erfolgreich)

  PACKET   := 1                      ' nummer startpaket
  RETRY    := 0                      ' fehlerzhler rcksetzen
  MODE     := 0                      ' Set Mode to zero
  EOF      := 0                      ' Set EOF to False
  
  ios.print(@msg10)
  ios.printnl
  
  REPEAT
    if ios.key == "c"
      QUIT
                                     ' auf sender warten
    ser.tx(NAK)                      ' NAK an sender um bereitschaft zu signalisieren
    XRECV := ser.rxtime (500)        ' 500 ms auf erstes zeichen oder timeout warten

    IF (XRECV == SOH)                ' SOH startet erstes paket
      MODE := 1                      ' mode 1 - pakettransfer
      QUIT                           ' raus aus der warteschleife
    'ios.print(@err2)                 ' fehlermeldung timeout

  if MODE == 1
    ios.print(@msg1)                   ' anzeige transfer gestartet
    'ios.print(@msg3)                  ' anzeige [SOH]
    ios.sdopen( "w",@parastr)          ' datei ffnen

  REPEAT WHILE MODE == 1             ' solange transfer-status
    CRC := 0                         ' prfsumme rcksetzen
    XRECV := ser.rx                  ' blocknummer empfangen
    ios.printchar(" ")               ' blocknummer nn: ausgeben
    ios.printhex(XRECV,2)
    ios.printchar(" ")

    IF (XRECV < PACKET - 1) OR (XRECV > PACKET)  ' blocknummer fehlerhaft
      MODE := 0                      ' transfer aus
      ios.print(@err1)               ' fehlermeldung ausgeben
      QUIT                           ' schleife beenden
    ELSE
      PACKET := XRECV                ' blocknummer setzen wenn richtig

    XRECV := ser.rx                  ' komplement der blocknummer empfangen
    TCNT := 0                        ' zeiger auf pufferstart setzen

    REPEAT 128                       ' 128 byte nutzdaten empfangen
      XBUF[TCNT] := ser.rx           
      CRC += XBUF[TCNT++]            ' prfsumme berechnen und zeiger erhhen

    XRECV := ser.rx                  ' empfange prfsumme vom sender
    IF (XRECV <> CRC)                ' prfsumme falsch?
      IF (RETRY < 10)                ' schon 10 x wiederholt?
        ser.tx(NAK)                  ' NAK an sender --> block wiederholen
        RETRY++                      ' wiederholung zhlen
        ios.print(@msg2)             ' [NAK] anzeigen
        REPEAT                       ' warte auf neuen blockanfang (neuer versuch)
          XRECV := ser.rx            ' zeichen empfangen
          IF (XRECV == SOH)          ' SOH
            'ios.print(@msg3)        ' anzeige [SOH]
            QUIT                     ' exit this repeat loop

      ELSE                           ' fehlerhaften block 10 x wiederholt?
          MODE := 0                  ' transfer endgltig abbrechen
          ios.print(@err3)           ' fehlermeldung ausgeben
          QUIT                       ' exit this repeat loop

    ELSE                             ' prfsumme ist richtig!
      ser.tx(ACK)                    ' quittiere mit ACK
      'ios.print(@msg4)              ' [ACK] ausgeben   
      'bwrite(@XBUF)                  ' block in datei schreiben
      'PACKET++                       ' blocknummer erhhen

      REPEAT                         ' nchster blockanfang 
        XRECV := ser.rx              ' startzeichen empfangen
        IF (XRECV == EOT)            ' bertragung beendet (EOT)?
          ser.tx(ACK)                ' send ACK
          waitcnt(clkfreq/10 + cnt)  ' wait 100mS
          ser.tx (ACK)               ' send ACK again
          MODE := 2                  ' Set mode to completed successfully
          ios.print(@msg5)           ' [EOT] ausgeben
          EOF := 1
          QUIT                       ' exit this repeat loop

        IF (XRECV == CAN)            ' bertragung abgebrochen (CAN)?
          MODE := 0                  ' Transfer aborted or incomplete
          ios.print(@msg6)           ' [CAN] ausgeben
          QUIT                       ' exit this repeat loop

        IF (XRECV == SOH)            ' nchster block (SOH)?
          'ios.print(@msg3)          ' anzeige [SOH]
          QUIT
      bwrite(@XBUF)                  ' block in datei schreiben
      PACKET++
          

  ios.sdclose                        ' datei schlieen
  ser.tx(13)
  ser.tx(13)
  ios.printnl

  IF (MODE == 2)                     ' abschlieende meldung
    ios.print(@msg7)                 ' transfer erfolgreich                                    
  ELSE
    ios.print(@err4)                 ' transfer abgebrochen                                


PUB bwrite(puffer) | n,i        ' schreibt 128 byte nutzdaten in datei

repeat i from 0 to 127
  n := byte[puffer][i]
  if EOF == 0
    ios.sdputc(n)
  else
    if n <> PAD
      ios.sdputc(n)

PUB rdpara
  if ios.paranext(@parastr)                            'parameter quelldatei einlesen
    ios.print(@msg8)
    ios.print(@parastr)
    ios.printnl
    modus := 1
  else
    ios.print(@err5)
    ios.printnl
    ios.print(@err6)
    ios.printnl
    return
    
DAT

'xfile         byte      "xfile.bin",0
'msg0          byte      13,"xload - 12-03-2009-kr",13,0
msg0          byte      13,"xLoad - 14-08-2009 JR",13,0
msg1          byte      "[INIT OK] ",13,0
msg2          byte      "[NAK] ",0
msg3          byte      "[SOH] ",0
msg4          byte      "[ACK] ",0
msg5          byte      "[EOT] ",0
msg6          byte      "[CAN] ",0
msg7          byte      "[Transfer ok] ",0
msg8          byte      "Zieldatei: ", 0
msg9          byte      "Zieldatei vorhanden! berschreiben? <j/n>: ", 0
msg10         byte      "Warte auf Datei. Abbrechen mit 'c'", 0

err1          byte      "[ERR: BLKNR] ",0
err2          byte      "[ERR: TimeOut] ",0
err3          byte      "[ERR: Transfer] ",0
err4          byte      "[ERR: Cancled] ",0
err5          byte      "Keine Zieldatei angegeben!",0
err6          byte      "Benutzung: xLoad <Ziel>",0



  